#ifndef __ZString_h__
#define __ZString_h__
/*
 * libzdt - zdt's own C Library.
 * Copyright (C) 1999,2000 Jeremy Tregunna. All rights reserved.
 *
 * libzdt is distributed under a modified version of the BSD license.
 * You should have received a copy of this license in the Documentation
 * directory.
 */
#include <zdt/Types.h>
#include <zdt/ZObject.h>
#include <objc/Object.h>
#include <objc/NXConstStr.h>

#include <string.h>
#include <sys/types.h>

/* Some macros */
#define	upcase(__c)	(((__c) >= 'a' && (__c) <= 'z') ? (__c) - 'a' + 'A' : (__c))
#define	whitespace(__c) (((__c) == 32) || ((__c) == 9) || ((__c) == 13) || ((__c) == 10))

@interface ZString : ZObject
{
	char *c_string;
	unsigned int len;
}

- (const char *)cString;
- (unsigned int)length;
- (int)ZPrintString:(NXConstantString *)format,...;
- (int)ZPrintError:(NXConstantString *)format,...;
- (char *)stristr:(char *)bigs littles:(char *)littles;
- (int)strnstr:(char *)buffer string:(char *)aString;
- (uint8 *)p2istr:(uint8 *)aString;
- (uint8 *)i2pstr:(uint8 *)aString;
- (void)p2istrncpy:(uint8 *)cString pString:(const uint8 *)pString maxLength:(int32)maxLength;
- (void)i2pstrncpy:(uint8 *)pString cString:(const uint8 *)cString maxLength:(int32)maxLength;
- (void)ZMemoryCopy:(uint8 *)dest source:(const uint8 *)source length:(unsigned int)length;
- (int)ZMemoryCompare:(const uint8 *)s1 s2:(const uint8 *)s2 length:(unsigned int)length;
- (void)ZMemoryZero:(uint8 *)dest length:(unsigned int)length;
- (voidpf)ZCAlloc:(voidpf)opaque items:(unsigned)items size:(unsigned)size;
- (void)ZCFree:(voidpf)opaque pointer:(voidpf)pointer;
- (void *)ZSearchMemory:(const void *)mem c:(int)c length:(int)length;
- (int)ZCaseInsensitiveMemoryCompare:(const char *)aString anotherString:(const char *)anotherString length:(size_t)length;
- (int)DoNumericCompare:(const char **)aString anotherString:(const char **)anotherString length:(size_t *)length;
- (int)DoStringCompare:(const char **)aString anotherString:(const char **)anotherString length:(size_t *)length;
- (int)DoCaseInsensitiveStringCompare:(const char **)aString anotherString:(const char **)anotherString length:(size_t *)length;
- (int)NumericStringCompare:(const char *)aString anotherString:(const char *)anotherString;
- (int)CaseInsensitiveNumericStringCompare:(const char *)aString anotherString:(const char *)anotherString;
- (int)NumericMemoryCompare:(const char *)aString anotherString:(const char *)anotherString length:(size_t)length;
- (int)CaseInsensitiveNumericMemoryCompare:(const char *)aString anotherString:(const char *)anotherString length:(size_t)length;
- (void)rmspace:(char *)aString;
- (void)SplitCharacter:(char *)first rest:(char *)rest divider:(char)divider;
- (void)Split:(char *)first rest:(char *)rest;
- (void)NSplit:(char *)first rest:(char *)rest;
- (void)Fatal:(NXConstantString *)aString recoverable:(int)recoverable;
- (void)GotSIGBUS:(int)z;
- (void)GotSIGSEGV:(int)z;
- (void)GotSIGFPE:(int)z;
- (void)GotSIGTERM:(int)z;
- (void)GotSIGQUIT:(int)z;
- (void)GotSIGHUP:(int)z;
- (void)GotSIGALRM:(int)z;

@end

#endif /* !__ZString_h__ */
