#ifndef __twofish_h__
#define __twofish_h__

#ifdef __cplusplus
extern "C" {
#endif

#define Q_TABLES
#define M_TABLE
#define MK_TABLE
#define ONE_STEP

typedef struct twofish_instance {
	uint32  k_len;
	uint32  l_key[40];
	uint32  s_key[4];
#ifdef  Q_TABLES
	uint32 qt_gen;
	uint8 q_tab[2][256];
#endif
#ifdef  M_TABLE
	uint32 mt_gen;
	uint32 m_tab[4][256];
#endif
#ifdef  ONE_STEP
	uint32 mk_tab[4][256];
#else
	uint8 sb[4][256];
#endif
} TWI;

void _zcrypt_twofish_set_key(TWI *pkey,const uint32 in_key[],const uint32 key_len);
void _zcrypt_twofish_encrypt(TWI *pkey,uint32 *in_blk);
void _zcrypt_twofish_decrypt(TWI *pkey,uint32 *in_blk);

#ifdef __cplusplus
}
#endif
#endif /* !__twofish_h__ */
