/*
 * libzdt - zdt's own C Library.
 * Copyright (C) 1999,2000 Jeremy Tregunna. All rights reserved.
 *
 * libzdt is distributed under a modified version of the BSD license.
 * You should have received a copy of this license in the Documentation
 * directory.
 */
#include <zdt/Types.h>
#include <zdt/version.h>

@implementation Version
/*
 * Print the full version of libzdt.
 */
- (const char *)FullVersion
{
	static char temp[16];

	sprintf(temp,"%s.%s.%s",__libzdtVersionMajor__,__libzdtVersionMinor__,__libzdtVersionPrepatch__);

	return(temp);
}

/*
 * Prints the major version number of libzdt.
 */
- (const char *)MajorVersion
{
	return(__libzdtVersionMajor__);
}

/*
 * Prints the minor version number of libzdt.
 */
- (const char *)MinorVersion
{
	return(__libzdtVersionMinor__);
}

/*
 * Prints the pre-patch version number of libzdt.
 */
- (const char *)PrePatchVersion
{
	return(__libzdtVersionPrepatch__);
}

/*
 * Prints the platform libzdt was written for.
 */
- (const char *)PlatformVersion
{
	return(__libzdtVersionPlatform__);
}

/*
 * Prints the architecture libzdt was written for.
 */
- (const char *)ArchitectureVersion
{
	return(__libzdtVersionArchitecture__);
}
